Subject: 24.4; Mac OS top menu: wrong menus pop up if system zoom is enabled

From: "Silas S. Brown" <[email-masked]>
Date: Sat, 25 Oct 2014 17:43:11 +0100

Hi, I can now confirm that the "pure build" of GNU Emacs 24.4
distributed for Mac OS X from http://emacsformacosx.com/ on 2014-10-20
contains the same bug that I earlier reported against Aquamacs at
http://comments.gmane.org/gmane.emacs.aquamacs.devel/992
(copied below).  The bug is new in Emacs 24.4 (it wasn't there
in Emacs 24.3).  I've reproduced it both on OS X 10.9.4 and OS X 10.7.

> Hi, I'm on a machine running OS X version 10.9.4 and I use
> System Preferences / Accessibility / Zoom to get 2x magnification
> of the entire screen.  When Zoom is turned on, clicking on the
> menubar in [Emacs] usually results in the wrong menu popping up.
> For example, clicking on "Window" causes the "Edit" menu to pop up,
> clicking on "Options" causes the "File" menu to pop up.  It seems
> to be interpreting the click as further to the left of where it
> actually is.  The menu does not STAY popped up however - as soon
> as the mouse is released, the menu goes away again.  The only way
> to access the menu options properly is to (1) click on the leftmost
> "[Emacs]" menu (or the Apple icon), (2) drag the mouse over the
> other menus - if you do THAT, you can get any menu you like to pop
> up and stay popped up.  Which is a nice workaround.  But it would
> be better if you could click on just any menu and have it pop up.
> 
> The bug hapens ONLY when Zoom is turned on.  I am using it at 2x
> magnification, which I set in Zoom's "More Options".  I set
> Minimum Zoom 0, Maximum Zoom 2, and pressed the Zoom In shortcut
> (which by default is Command-Alt-Plus).
> 
> This is the first time I have known ANY application to behave
> differently when Zoom is on compared to when it is off.  I didn't
> know the applications even KNEW about zoom (I thought it was all
> 'under the carpet' as far as applications are concerned).  Maybe
> [Emacs] is trying to override the behaviour of the menu bar at
> such a low level that it's being tripped up by this.

In GNU Emacs 24.4.1 (x86_64-apple-darwin13.4.0, NS apple-appkit-1265.21)
 of 2014-10-20 on builder10-9.porkrind.org
Windowing system distributor `Apple', version 10.3.1265
Configured using:
 `configure --with-ns'

Important settings:
  locale-coding-system: utf-8-unix

Major mode: Fundamental

Minor modes in effect:
  display-time-mode: t
  shell-dirtrack-mode: t
  show-paren-mode: t
  tooltip-mode: t
  electric-indent-mode: t
  mouse-wheel-mode: t
  menu-bar-mode: t
  file-name-shadow-mode: t
  global-font-lock-mode: t
  font-lock-mode: t
  auto-composition-mode: t
  auto-encryption-mode: t
  auto-compression-mode: t
  column-number-mode: t
  line-number-mode: t
  transient-mark-mode: t

Recent input:
<menu-bar> <help-menu> <send-emacs-bug-report>

Recent messages:
Loading /home/ssb22/.xemacs/cjkmail.el (source)...done
Loading /home/ssb22/.xemacs/print.el (source)...done
Loading /home/ssb22/.xemacs/misc.el (source)...done
Loading /home/ssb22/.xemacs/desktop.el (source)...
(New file)
Saving file /home/ssb22/.vm.windows...
Wrote /home/ssb22/.vm.windows
Loading /home/ssb22/.xemacs/desktop.el (source)...done
Loading /home/ssb22/.xemacs/init.el (source)...done
For information about GNU Emacs and the GNU system, type C-h C-a.

Load-path shadows:
None found.

Features:
(shadow sort mail-extr warnings emacsbug message rfc822 mml easymenu
mml-sec mm-decode mm-bodies mm-encode mail-parse rfc2231 mailabbrev
gmm-utils mailheader sendmail rfc2047 rfc2045 ietf-drums mail-utils time
time-stamp tramp tramp-compat auth-source eieio eieio-core gnus-util
mm-util mail-prsvr password-cache tramp-loaddefs trampver shell
pcomplete comint ansi-color ring format-spec jka-compr paren byte-opt
bytecomp byte-compile cconv advice help-fns edmacro kmacro zoom-frm
frame-cmds frame-fns cl-macs avoid cl gv cl-loaddefs cl-lib wenlin-mode
sgml-mode time-date tooltip electric uniquify ediff-hook vc-hooks
lisp-float-type mwheel ns-win tool-bar dnd fontset image regexp-opt
fringe tabulated-list newcomment lisp-mode prog-mode register page
menu-bar rfn-eshadow timer select scroll-bar mouse jit-lock font-lock
syntax facemenu font-core frame cham georgian utf-8-lang misc-lang
vietnamese tibetan thai tai-viet lao korean japanese hebrew greek
romanian slovak czech european ethiopic indian cyrillic chinese
case-table epa-hook jka-cmpr-hook help simple abbrev minibuffer nadvice
loaddefs button faces cus-face macroexp files text-properties overlay
sha1 md5 base64 format env code-pages mule custom widget
hashtable-print-readable backquote make-network-process cocoa ns
multi-tty emacs)

Memory information:
((conses 16 107807 4595)
 (symbols 48 21281 0)
 (miscs 40 48 129)
 (strings 32 21736 2971)
 (string-bytes 1 625626)
 (vectors 16 13398)
 (vector-slots 8 445554 2518)
 (floats 8 77 48)
 (intervals 56 192 8)
 (buffers 960 13))

-- 
Silas S Brown http://people.ds.cam.ac.uk/ssb22